#!/bin/sh
#

cat <<EOF

It is not neccessary to call this script anymore. 
The start-up script will evaluate etc/doors_config and start
the according doors with the correct domain- and cell-names.

EOF
exit 0


ADMIN_CONFIG=/opt/d-cache/etc/node_config.template
DCACHE_BASE_DIR=`cat $ADMIN_CONFIG | grep DCACHE_BASE_DIR |awk '{print $3}'`
ADMIN_SETUP_TEMPLATE=$DCACHE_BASE_DIR/etc/dCacheSetup
DOOR_CONFIG=$DCACHE_BASE_DIR/etc/door_config
PNFS_ROOT=`cat $ADMIN_CONFIG | grep PNFS_ROOT |awk '{print $3}'`
ADMIN_NODE=`cat $DOOR_CONFIG | grep ADMIN_NODE | awk '{print $2}'`
echo "Checking existence of door_config file"
if [ ! -f $DOOR_CONFIG ]; then
   echo "Copy door_config.template to door_config and customize it before running the install script"
   exit 1
fi
#
# Get the hostname
#
hn=`eval hostname | awk -F. '{print $1}'`
#Check whether to activate doors
GSIDCAP=`cat $DOOR_CONFIG | grep GSIDCAP | awk '{print $2}'`
# GSIDCAP_MODE=`cat $DOOR_CONFIG | grep GSIDCAP | awk '{print $3}'`
# echo "gsidcap=$GSIDCAP, $GSIDCAP_MODE"
GRIDFTP=`cat $DOOR_CONFIG | grep GRIDFTP | awk '{print $2}'`
# GRIDFTP_MODE=`cat $DOOR_CONFIG | grep GRIDFTP | awk '{print $3}'`
# echo "gridftp=$GRIDFTP, $GRIDFTP_MODE"
SRM=`cat $DOOR_CONFIG | grep SRM | awk '{print $2}'`
# SRM_MODE=`cat $DOOR_CONFIG | grep SRM | awk '{print $3}'`
# echo "srm=$SRM, $SRM_MODE"
#
# Prepare start-up script (dcache-opt)
#
cp $DCACHE_BASE_DIR/etc/dcache-opt.template $DCACHE_BASE_DIR/bin/dcache-opt
# Install ssh keys for secure communication
cd $DCACHE_BASE_DIR/config
if [ -f ./server_key ]; then
   rm -f ./server_key; rm -f ./host_key
fi
ssh-keygen -b 768 -t rsa1 -f ./server_key -N ""
ln -s /etc/ssh/ssh_host_key ./host_key

#
# Test GRIDFTP door config
#
if [ \( "$GRIDFTP" = "y" \) -o \( "$GRIDFTP" = "yes" \) ] ; then
   SED="
   s|\(echo \"No GridFTP door to start\).*|\$dCache_location/jobs/gridftpdoor-"$hn" -logfile=\$dCache_location/log/gridftpdoor-"$hn".log start|
   "

   sed "$SED" $DCACHE_BASE_DIR/bin/dcache-opt > $DCACHE_BASE_DIR/config/gridftpdoor-tmp
   cp $DCACHE_BASE_DIR/config/gridftpdoor-tmp $DCACHE_BASE_DIR/bin/dcache-opt
   SED="
   s|\(echo \"No GridFTP door to stop\).*|\$dCache_location/jobs/gridftpdoor-"$hn" stop|
   "

   sed "$SED" $DCACHE_BASE_DIR/bin/dcache-opt > $DCACHE_BASE_DIR/config/gridftpdoor-tmp
   cp $DCACHE_BASE_DIR/config/gridftpdoor-tmp $DCACHE_BASE_DIR/bin/dcache-opt
#  if [ \( "$GRIDFTP_MODE" = "s" \) -o \( "$GRIDFTP_MODE" = "slave" \) ] ; then
#      cp $DCACHE_BASE_DIR/config/gridftpdoor-slave.template $DCACHE_BASE_DIR/config/gridftpdoor-$hn.batch
#      SED="
#      s|GFTP|GFTP-"$hn"|
#      "
#
#      sed "$SED" $DCACHE_BASE_DIR/config/gridftpdoor-$hn.batch > $DCACHE_BASE_DIR/config/gridftpdoor-tmp
#      cp $DCACHE_BASE_DIR/config/gridftpdoor-tmp $DCACHE_BASE_DIR/config/gridftpdoor-$hn.batch
#   fi
#   if [ \( "$GRIDFTP_MODE" = "m" \) -o \( "$GRIDFTP_MODE" = "master" \) ] ; then
      cp $DCACHE_BASE_DIR/config/gridftpdoor.batch $DCACHE_BASE_DIR/config/gridftpdoor-$hn.batch
      SED="      s|GFTP|GFTP-"$hn"|
      "

      sed "$SED" $DCACHE_BASE_DIR/config/gridftpdoor-$hn.batch > $DCACHE_BASE_DIR/config/gridftpdoor-tmp
      cp $DCACHE_BASE_DIR/config/gridftpdoor-tmp $DCACHE_BASE_DIR/config/gridftpdoor-$hn.batch
#   fi
fi
#
# Test GSIDCAP door config
#
if [ \( "$GSIDCAP" = "y" \) -o \( "$GSIDCAP" = "yes" \) ] ; then
   SED="
   s|\(echo \"No GsidCap door to start\).*|\$dCache_location/jobs/gsidcapdoor-"$hn" -logfile=\$dCache_location/log/gsidcapdoor-"$hn".log start|
   "

   sed "$SED" $DCACHE_BASE_DIR/bin/dcache-opt > $DCACHE_BASE_DIR/config/gridftpdoor-tmp
   cp $DCACHE_BASE_DIR/config/gridftpdoor-tmp $DCACHE_BASE_DIR/bin/dcache-opt
   SED="
   s|\(echo \"No GsidCap door to stop\).*|\$dCache_location/jobs/gsidcapdoor-"$hn" stop|
   "

   sed "$SED" $DCACHE_BASE_DIR/bin/dcache-opt > $DCACHE_BASE_DIR/config/gridftpdoor-tmp
   cp $DCACHE_BASE_DIR/config/gridftpdoor-tmp $DCACHE_BASE_DIR/bin/dcache-opt
#   if [ \( "$GSIDCAP_MODE" = "s" \) -o \( "$GSIDCAP_MODE" = "slave" \) ] ; then
#      cp $DCACHE_BASE_DIR/config/gsidcapdoor-slave.template $DCACHE_BASE_DIR/config/gsidcapdoor-$hn.batch
#      SED="
#      s|DCap-gsi|DCap-gsi-"$hn"|
#      "
#
#      sed "$SED" $DCACHE_BASE_DIR/config/gsidcapdoor-$hn.batch > $DCACHE_BASE_DIR/config/gsidcapdoor-tmp
#      cp $DCACHE_BASE_DIR/config/gsidcapdoor-tmp $DCACHE_BASE_DIR/config/gsidcapdoor-$hn.batch
#   fi
#   if [ \( "$GSIDCAP_MODE" = "m" \) -o \( "$GSIDCAP_MODE" = "master" \) ] ; then
      cp $DCACHE_BASE_DIR/config/gsidcapdoor.batch $DCACHE_BASE_DIR/config/gsidcapdoor-$hn.batch
      SED="
      s|DCap-gsi|DCap-gsi-"$hn"|
      "

      sed "$SED" $DCACHE_BASE_DIR/config/gsidcapdoor-$hn.batch > $DCACHE_BASE_DIR/config/gsidcapdoor-tmp
      cp $DCACHE_BASE_DIR/config/gsidcapdoor-tmp $DCACHE_BASE_DIR/config/gsidcapdoor-$hn.batch
#   fi
fi
#
# Test SRM door config
#
if [ \( "i$SRM" = "y" \) -o \( "$SRM" = "yes" \) ] ; then
   SED="
   s|\(echo \"No SRM door to start\).*|\$dCache_location/jobs/srm-"$hn" -logfile=\$dCache_location/log/srm-"$hn".log start|
   "

   sed "$SED" $DCACHE_BASE_DIR/bin/dcache-opt > $DCACHE_BASE_DIR/config/gridftpdoor-tmp
   cp $DCACHE_BASE_DIR/config/gridftpdoor-tmp $DCACHE_BASE_DIR/bin/dcache-opt
   SED="
   s|\(echo \"No SRM door to stop\).*|\$dCache_location/jobs/srm-"$hn" stop|
   "

   sed "$SED" $DCACHE_BASE_DIR/bin/dcache-opt > $DCACHE_BASE_DIR/config/gridftpdoor-tmp
   cp $DCACHE_BASE_DIR/config/gridftpdoor-tmp $DCACHE_BASE_DIR/bin/dcache-opt
#   if [ \( "$SRM_MODE" = "s" \) -o \( "$SRM_MODE" = "slave" \) ] ; then
#      cp $DCACHE_BASE_DIR/config/srm-slave.template $DCACHE_BASE_DIR/config/srm-$hn.batch
#      SED="
#      s|SRM|SRM-"$hn"|
#      "
#
#      sed "$SED" $DCACHE_BASE_DIR/config/srm-$hn.batch > $DCACHE_BASE_DIR/config/srm-tmp
#      cp $DCACHE_BASE_DIR/config/srm-tmp $DCACHE_BASE_DIR/config/srm-$hn.batch
#   fi
#   if [ \( "$SRM_MODE" = "m" \) -o \( "$SRM_MODE" = "master" \) ] ; then
      cp $DCACHE_BASE_DIR/config/srm.batch $DCACHE_BASE_DIR/config/srm-$hn.batch
      SED="
      s|SRM|SRM-"$hn"|
      "

      sed "$SED" $DCACHE_BASE_DIR/config/srm-$hn.batch > $DCACHE_BASE_DIR/config/srm-tmp
      cp $DCACHE_BASE_DIR/config/srm-tmp $DCACHE_BASE_DIR/config/srm-$hn.batch
#   fi
fi
#
# Stuff in common (initPackage, link etc.)
#
if [ \( "$GRIDFTP" = "n" \) -o \( "$GRIDFTP" = "no" \) ] ; then
   if [ \( "$GSIDCAP" = "n" \) -o \( "$GSIDCAP" = "no" \) ] ; then
      if [ \( "$SRM" = "n" \) -o \( "$SRM" = "no" \) ] ; then
         echo "nothing to be done (pnfs mount, link)"
         exit 0
      fi
   fi
fi
#
# Active doors found
#
   $DCACHE_BASE_DIR/jobs/initPackage.sh
   if [ ! -d /pnfs ]; then
   mkdir -p /pnfs
   mkdir /pnfs/fs
   fi
# echo "mount -o intr,rw,noac,hard $ADMIN_NODE:/fs /pnfs/fs"
   SID="`cat /etc/resolv.conf| grep search | awk '{ print($2) }'`"
   if [ -z $SID ]; then
      SID="`cat /etc/resolv.conf| grep domain | awk '{ print($2) }'`"
   fi
   # Map /pnfs/fs/usr to /pnfs/domain (e.g. /pnfs/fnal.gov) for GridFTP/SRM
   cd $PNFS_ROOT
   if [ -h $SID ]; then
        echo "$PNFS_ROOT/$SID - link exists"
      else
        ln -s fs/usr $SID
   fi
exit 0
