#!/bin/sh
#
#build_srm=true
goUp() {
#
# on linux we could use 'realpath'
#
  m=`pwd`
  m=`basename $m`
  cd ..
  x=`ls -ld $m 2>/dev/null | awk '/ -> /{ print $NF }' 2>/dev/null`
  if [ ! -z "$x" ]  ; then
     m=$x
     m=`echo $m | awk -F/ '{ for(i=1;i<NF;i++)printf "%s/",$i }'`
     cd $m
  fi
}
printf " Checking JVM ........ "
which java 1>/dev/null 2>/dev/null
if [ $? -ne 0 ] ; then
  echo "Failed : Java stuff not found on PATH" 
  exit 4
fi
version=`java -version 2>&1 | grep version | awk '{print $3}'`
x=`expr $version : "\"\(.*\)\"" | awk -F. '{ print $2 }'`
if [ "$x" -lt 3 ] ; then
   echo "Failed : Insufficient Java Version : $version"
   exit 4
fi
echo "Ok"
#
printf " Checking Cells ...... "
if [ ! -f "../classes/cells.jar" ] ; then
  echo "Failed : cells.jar not found in ../classes"
  exit 4
fi
echo "Ok"
if [ "$build_srm" ]; then
    printf " Checking GLUE ...... "
    if [ ! -f "../classes/glue/GLUE-STD.jar" ] ; then
      echo "Failed : GLUE-STD.jar not found in ../classes"
      exit 4
    fi
    if [ ! -f "../classes/glue/dom.jar" ] ; then
      echo "Failed : dom.jar not found in ../classes"
      exit 4
    fi
    if [ ! -f "../classes/glue/jnet.jar" ] ; then
      echo "Failed : jnet.jar not found in ../classes"
      exit 4
    fi
    if [ ! -f "../classes/glue/jsse.jar" ] ; then
      echo "Failed : jsse.jar not found in ../classes"
      exit 4
    fi
    if [ ! -f "../classes/glue/jcert.jar" ] ; then
      echo "Failed : jcert.jar not found in ../classes"
      exit 4
    fi
    if [ ! -f "../classes/glue/servlet.jar" ] ; then
      echo "Failed : servlet.jar not found in ../classes"
      exit 4
    fi
    echo "Ok"
    printf " Checking Globus ...... "
    if [ ! -f "../classes/globus/cog.jar" ] ; then
      echo "Failed : .jar not found in ../classes/globus"
      exit 4
    fi
    if [ ! -f "../classes/globus/iaik_javax_crypto.jar" ] ; then
      echo "Failed : .jar not found in ../classes/globus"
      exit 4
    fi
    if [ ! -f "../classes/globus/iaik_jce_full.jar" ] ; then
      echo "Failed : .jar not found in ../classes/globus"
      exit 4
    fi
    if [ ! -f "../classes/globus/iaik_ssl.jar" ] ; then
      echo "Failed : .jar not found in ../classes/globus"
      exit 4
    fi
    if [ ! -f "../classes/globus/log4j-core.jar" ] ; then
      echo "Failed : .jar not found in ../classes/globus"
      exit 4
    fi
    echo "Ok"
fi
#
printf " Compiling dCache .... "
#
export CLASSPATH
if [ "$build_srm" ]; then
    CLASSPATH=../classes/cells.jar
    CLASSPATH=$CLASSPATH:../classes/glue/GLUE-STD.jar:../classes/glue/dom.jar
    CLASSPATH=$CLASSPATH:../classes/glue/jnet.jar:../classes/glue/jsse.jar
    CLASSPATH=$CLASSPATH:../classes/glue/jcert.jar:../classes/glue/servlet.jar
    CLASSPATH=$CLASSPATH:../classes/globus/cog.jar
    CLASSPATH=$CLASSPATH:../classes/globus/iaik_javax_crypto.jar
    CLASSPATH=$CLASSPATH:../classes/globus/iaik_jce_full.jar
    CLASSPATH=$CLASSPATH:../classes/globus/iaik_ssl.jar
    CLASSPATH=$CLASSPATH:../classes/globus/log4j-core.jar
    javac `find .. -name "*.java"`
else
    CLASSPATH=../classes/cells.jar:../..
    javac `find .. -name "*.java" | grep -v srm`
fi
    
if [ $? -ne 0 ] ; then
  echo ""
  echo "  !!! Error in compiling dCache " 1>&2
  exit 5
fi
rm -rf ../classes/dcache.jar 2>/dev/null
echo "Ok"
#
printf " Making dcache.jar ... "
(  goUp ;
   goUp ; 
  rm -rf diskCacheV111/classes/dcache.jar
  jar cf diskCacheV111/classes/dcache.jar `find . -name "*.class"`
 )
echo "Done" 
#
printf " dCacheVersion ....... "
CLASSPATH=../classes/cells.jar:../classes/dcache.jar
version=`java diskCacheV111.util.Version 2>/dev/null`
if [ $? -ne 0 ] ; then
  echo "Failed"
else
  echo "Version $version"
fi
goUp
cd config

if [ "otto" = "karl" ] ;then
if [ -f dCacheSetup ] ;then
   echo " Warning : we found a used dCacheSetup file"
   echo " Is it still correct ?"
else
   cp dCacheSetup.temp dCacheSetup
   echo "   A new dCache setup master file has been created."
   echo "   It needs to be custumized"
fi
fi
printf " Preparing config .... "
#
cat >./extract-dcache <<!
./docs/images/eagle_logo.gif
./docs/images/eagle-main.gif
./docs/images/eagle-grey.gif
./docs/images/eagleredtrans.gif
./docs/images/trudey.gif
./docs/images/sorry.gif
./docs/images/redbox.gif
./docs/images/greenbox.gif
./docs/images/yellowbox.gif
./docs/images/bg.jpg
./jobs/needFulThings.sh
./jobs/generic.lib.sh
./jobs/wrapper.sh
./jobs/wrapper2.sh
./jobs/initPackage.sh
./jobs/hsmcp.sh
./jobs/encp.sh
./jobs/osm-hsmcp.sh
./jobs/remote-osmcp.sh
./jobs/rosm-hsmcp.sh
./config/dCacheSetup.temp
./config/PoolManager.conf.temp
./config/defaultPools.poollist.temp
./config/lm.config.temp
./config/setup.temp
!
#
for batchName in *.batch  ; do
  echo ./config/$batchName >>./extract-dcache
done

if [ -f ./extract.local ] ; then cat extract.local >>./extract-dcach ;fi
#
# may contain patch-*.jar as well
#
( cd .. ; find ./classes -name "*.jar" -print >>./config/extract-dcache )
#
# currently only needed to support pam's
#
( cd .. ; 
  if [ -d ./lib ]
  then  
    find ./lib -type f -print >>./config/extract-dcache
  fi
)
#
echo "Done"
#
#
goUp
find ./scripts -type f -print >> config/extract-dcache
tar cf dcache.tar -T config/extract-dcache
echo ""
echo " Distribution on `pwd`/dcache.tar"
echo ""
exit 0 
